!DIR$ FIXEDFORMLINESIZE:132
      pure subroutine make_points(pind, Mode, cq_in, z1, z2, z3, F1, F2, F3, info)
      use dblocks
      implicit none
      integer*4 , intent(in)  :: pind, Mode
      complex*16, intent(in)  :: cq_in(1:3)
      complex*16, intent(out) :: z1, z2, z3
      complex*16, intent(out) :: F1, F2, F3
      integer*4 , intent(out) :: info

      complex*16 cF, cq(1:3)

      interface
         pure subroutine make_cF(Mode, cq, cF)
         use dblocks
         integer*4,  intent(in)    :: Mode
         complex*16, intent(inout) :: cq(1:3)
         complex*16, intent(out)   :: cF
         end subroutine make_cF
      end interface

      cq   = cq_in
      info = 0

      IF(pind .eq. 1) THEN

         z1 = cq(3)
         call make_cF(Mode, cq, cF)
         F1 = z1*z1 - rk2*cF
         if(cdabs(F1) .le. eps) then
            info = 1
            return
         end if

         z2 = rk * cdsqrt(cF)
         cq(3) = z2
         call make_cF(Mode, cq, cF)
         F2 = z2*z2 - rk2*cF
         if(cdabs(F2) .le. eps) then
            info = 2
            return
         end if
      
         z3 = rk * cdsqrt(cF)
         cq(3) = z3
         call make_cF(Mode, cq, cF)
         F3 = z3*z3 - rk2*cF
         if(cdabs(F3) .le. eps) then
            info = 3
            return
         end if

      ELSE

         z1 = cq(3)
         call make_cF(Mode, cq, cF)
         F1 = z1*z1 - rk2*cF

         z2    = z1 - del
         cq(3) = z2
         call make_cF(Mode, cq, cF)
         F2 = z2*z2 - rk2*cF
      
         z3    = z1 + del
         cq(3) = z3
         call make_cF(Mode, cq, cF)
         F3 = z3*z3 - rk2*cF

      END IF


      return
      end
